
#include <stdio.h>
#include "board.h"
#include "dbgu.h"
//#include "cdc_enumerate.h"

//* ----------------------- External Function Prototype -----------------------

//void AT91F_DBGU_Init(void);
//void AT91F_DBGU_Printk( char *buffer);
//void AT91F_DBGU_Frame(  char *buffer);
//int AT91F_DBGU_Get( char *val);
//void AT91F_DBGU_scanf(char * type,unsigned int * val);
//void AT91F_DBGU_PutChar(char mychar);


#define FLASH_CS 0
#define DAC_CS   1

#define LAST_XFER     (unsigned char)1 // must be == 1
#define NOT_LAST_XFER (unsigned char)0 // must be == 0


//struct _AT91S_CDC 	pCDC;




//void LedsInit(void);

void            SPI_Init(void);
void            LEDS_Init(void);
void            RESET_Init(void);
void            USB_Init(void);
void            USB_Start(void);
void            USB_Do(void);
//unsigned char   SPI_Send(unsigned char data, unsigned char pcs, unsigned char lastxfer);
unsigned int    SPI_Send(unsigned int data, unsigned char pcs, unsigned char lastxfer);

// AT45 memory service functions

int AT45_Init(void);
int AT45_Ready(void);
int AT45_Compare(void);

//all operations via buffer_1 of the AT45 memory

void AT45_WriteBuffer(unsigned char * ptr);
void AT45_WritePageFromBuffer(unsigned int page);
void AT45_CopyPage(unsigned int page);

// HI LEVEL FUNCTIONS

void AT45_WritePage(unsigned int page, unsigned char * ptr);
void AT45_ReadPage(unsigned int page, unsigned char * ptr);
unsigned char AT45_ReadByte(unsigned int page,unsigned int byte);


// xmodem for receiving

void XModem(void);
unsigned int calcrc(unsigned char *ptr, int count);

// end of file

